// Generated by CoffeeScript 1.12.7
var basename, extname, find, fsExtra, functionTypes, getFunctionParameters, getMainExportValue, isFunction, isMainExportStatement, isNil, map, mergeAll, objOf, parse, pathEq, prop, ref, ref1, resolveStatement;

ref = require('path'), basename = ref.basename, extname = ref.extname;

parse = require('@babel/parser').parse;

ref1 = require('ramda'), prop = ref1.prop, isNil = ref1.isNil, map = ref1.map, mergeAll = ref1.mergeAll, objOf = ref1.objOf, pathEq = ref1.pathEq, find = ref1.find;

fsExtra = require('fs-extra');

functionTypes = new Set(['FunctionDeclaration', 'FunctionExpression', 'ArrowFunctionExpression']);

isFunction = function(statement) {
  return functionTypes.has(statement.type);
};

getMainExportValue = function(statement) {
  if (statement.type === 'ExpressionStatement') {
    return statement.expression.right;
  } else {
    return statement.declaration;
  }
};

resolveStatement = function(fullBody, statement) {
  if (statement.type === 'Identifier') {
    return find(pathEq(['id', 'name'], statement.name), fullBody);
  } else {
    return statement;
  }
};

getFunctionParameters = function(functionNode) {
  return functionNode.params.map(prop('name'));
};

isMainExportStatement = function(item) {
  var left, type;
  type = item.type;
  if (type === 'ExpressionStatement' && item.expression.type === 'AssignmentExpression') {
    left = item.expression.left;
    if (left.type === 'MemberExpression' && left.object.name === 'module' && left.property.name === 'exports') {
      return true;
    }
    return false;
  }
  return type === 'ExportDefaultDeclaration';
};

module.exports = function(arg) {
  var name, path;
  name = arg[0], path = arg[1];
  return fsExtra.readFile(path, 'utf-8').then(function(code) {
    var ast, body, mainExportStatement, resolvedMainExportStatement;
    ast = parse(code, {
      sourceType: 'unambiguous',
      plugins: ['jsx']
    });
    body = ast.program.body;
    mainExportStatement = find(isMainExportStatement, body);
    resolvedMainExportStatement = resolveStatement(body, getMainExportValue(mainExportStatement));
    if (isNil(resolvedMainExportStatement) || !isFunction(resolvedMainExportStatement)) {
      return {};
    } else {
      return objOf(name, getFunctionParameters(resolvedMainExportStatement));
    }
  });
};
